package es.guia.db.adapters;

import java.util.*;

import android.content.ContentValues;
import android.content.Context;

import es.guia.db.*;
import es.guia.beans.*;
import android.database.*;
import android.database.sqlite.*;
import android.util.Log;

public class ImageAdapter {
	
	//Declaracin de campos de la entidad TipoPOI
	
	public static final String ID = "ID";
	public static final String IMAGEN = "IMAGEN";
	public static final String POI = "ID_POI";
	
	
	final String DATABASE_TABLE="GALERIA";
	
	//
	private GuiaDatabaseHelper guiaDatabaseHelper;
	private SQLiteDatabase db;
	private Context context;
	
	
	public ImageAdapter(Context context){
		this.context=context;
		open();
		Log.i("Guia", "Conexin lista para ser utilizada");
	}
	
	
	
	public ImageAdapter open() throws SQLException{
		guiaDatabaseHelper=new GuiaDatabaseHelper(context);
		db=guiaDatabaseHelper.getWritableDatabase();
		
		return this;
	}
	
	public void close() throws SQLException{
		db.close();
		guiaDatabaseHelper.close();
	}
	

	
	/**
	* Consulta la galera de imgenes de un punto dado.
	*
	*/
	
	public Vector<String> getGalleryImages(String idPOI) throws SQLException{
		Log.d("Guia","Consultando el punto con id: "+idPOI);
		
		String[] params=new String[]{idPOI};
	
		Cursor cursor=db.query(DATABASE_TABLE, new String[]{IMAGEN}, "id_poi=?", params, null, null, null);
		
		Vector<String> listaImagenes=new Vector<String>();
		
		if(!cursor.moveToNext()) return listaImagenes;
		do{
			String imagen=cursor.getString(0);
			Log.d("Guia","Recuperada imagen: "+imagen);
			listaImagenes.add(imagen);
		}while(cursor.moveToNext());
		
		cursor.close();
		close();
		
		return listaImagenes;
	}
	
	
	public long insert(String imagen, String idPOI) throws SQLException{
		ContentValues content=createContent(imagen,idPOI);
		return db.insert(DATABASE_TABLE, null, content);
	}
	
	/**
	 * Crea un ContentValue para operar con los mtodos CRUD de este adaptador.
	 */
	
	private ContentValues createContent(String imagen, String idPoi){
		ContentValues content = new ContentValues();
		content.put("IMAGEN", imagen);
		content.put("ID_POI", idPoi);
		
		return content;
		
	}
	
}
