package es.guia.interfaz;

import java.io.*;
import java.net.*;
import java.nio.charset.Charset;
import java.util.*;

import android.app.Activity;
import android.content.Context;
import android.location.*;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.webkit.WebView;
import android.widget.*;


import com.google.gson.*;
import com.google.gson.stream.*;

import es.guia.beans.*;

public class CalculoRuta extends Activity {
	
	final String mimetype = "text/html; charset=iso-8859-1";
	final String encoding = "UTF-8";
	
	@Override
	 public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ruta);
        
        Log.d("CalculoRuta","llego al calculo de ruta");
        
        String longitudDestino= (String)(getIntent().getExtras()).get("longitudDestino");
        String latitudDestino= (String)(getIntent().getExtras()).get("latitudDestino");
        
        Log.d("longitudDestino",longitudDestino);
        Log.d("latitudDestino",latitudDestino);
        
        //TextView texto=(TextView)findViewById(R.id.lecturaJSON);
        WebView texto=(WebView)findViewById(R.id.webview);
        
        
        //Calculo posicin actual
        LocationManager locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        
      //Posicin actual
		Criteria criteria=new Criteria();
		String bestProvider=locationManager.getBestProvider(criteria, true);
		Location loc=locationManager.getLastKnownLocation(bestProvider);
        
        if(loc==null) Log.e("CalculoRuta","La localizacion actual es nula. El proveedor de GPS podra no estar operativo.");
        
        Log.d("calculoposicion","finaliza el calculo de posicion"); 
        Log.d("INFORMACION","Comienza el proceso de conexion ...");
        
        try{
        	//URL url= new URL("http://maps.google.com/maps/api/directions/json?origin=40.4138,-3.6903&destination=40.4138,-3.692386&sensor=true&mode=walking&language=es");
        	Log.d("INFORMACION","Preparando conexion ...");
        	URL url= new URL("http://maps.google.com/maps/api/directions/json?origin="
        			+loc.getLatitude()+","+loc.getLongitude()
        			+"&destination="+latitudDestino+","+longitudDestino
        			+"&sensor=true&mode=walking&language=es");
        	
        	URLConnection urlCon=url.openConnection();
        	Log.d("INFORMACION","Conexion abierta ...");
        	InputStream in=urlCon.getInputStream();
        	
        	StringBuffer store=new StringBuffer();
        	//DataInputStream dataIn=new DataInputStream(in);
        	
        	byte [] b=new byte[1024];
    		int n=0;
    		while ((n=in.read(b))>0){
    			store.append(new String(b, 0, n, "UTF-8"));
    			//store.append(new String(b, 0, n, Charset.forName("UTF-8")));
    		}
        	
    		in.close();
        	//dataIn.close();
        	
        	Toast.makeText(getBaseContext(), "Finalizado calculo de ruta" , Toast.LENGTH_LONG).show();
        	
        	
    		StringBuffer txt=new StringBuffer();
    		txt.append("<html><head><style>" +
    				"div.paso {" +
    				"background-color: #95abb7;" +
    				"float:center;" +
    				"margin-top: 2px;margin-right: 4px;" +
    				"color: #ffffff;border-radius: 1em 4em 1em 4em;" +
    				"font-family: verdana;"+
    				"font-size: 11;"+
    				"text-align: left; " +
    				"border-radius: 5px;"+
    				"-moz-border-radius: 5px;}"+
    				"div.cabecera {" +
    				"background-color: #0e4b6a;" +
    				"float:center;" +
    				"margin-top: 2px;margin-right: 4px;" +
    				"color: #ffffff;border-radius: 1em 4em 1em 4em;" +
    				"font-family: arial;"+
    				"font-size: 13;"+
    				"text-align: left; " +
    				"border-radius: 5px;"+
    				"-moz-border-radius: 5px;}"+
    				"</style>"+
    				"<body bg-color=\"#f2f3f5\">");
    	
    		//Parseo de la respuesta JSon 
        	Gson gson=new Gson();	
    		Ruta ruta=gson.fromJson(store.toString(), Ruta.class);	
    	
    		Routes route=(Routes)(ruta.getRoutes()).get(0);
    		List<Legs> legs=route.getLegs();
    		
    		String stDest=null;
    		
    		for(int i=0;i<legs.size();i++){
    			Legs leg=(Legs)legs.get(i);
    			
    			stDest=leg.getEnd_address();
    			txt.append("<div class=\"cabecera\">");
    			txt.append("De: <br/><b><i>"+leg.getStart_address()+"</i></b><br/> a:<br/> <b><i>"+leg.getEnd_address()+"<i></b><br/><br/>");
    			txt.append("<hr/>");
    			txt.append("<center><b>Distancia del recorrido:</b> "+leg.getDistance().getText()+"</center><br/></div>");
    			
    			List<Steps> pasos=leg.getSteps();
    			
    			for(int k=0;k<pasos.size();k++){
    				Steps step=(Steps)pasos.get(k);
    				//System.out.println(step.getDistance().getText()+", "+step.getDuration().getText()+" "+step.getHtml_instructions());
    				txt.append("<div class=\"paso\">");
    				txt.append("<p>");
    				txt.append(step.getDistance().getText()+", "+step.getDuration().getText()+" "+step.getHtml_instructions()+"<br/>");
    				if(step.getHtml_instructions().indexOf("derecha")!=-1){
    					txt.append("<center><img src=\"file:///android_asset/right-arrow.png\" /></center>");
    				}else if(step.getHtml_instructions().indexOf("izquierda")!=-1){
    					txt.append("<center><img src=\"file:///android_asset/left-arrow.png\" /></center>");
    				}else if(step.getHtml_instructions().indexOf("Cont")!=-1 || step.getHtml_instructions().indexOf("recto")!=-1){
    					txt.append("<center><img src=\"file:///android_asset/go-arrow.png\" /></center>");
    					
    				}
    				txt.append("</p>");
    				txt.append("</div>");
    				
    			}
    			
    			
    		}
        	
        	txt.append("<div class=\"cabecera\">");
        	txt.append("Ha llegado a su destino: <br/><br/>");
        	txt.append("<b><i>"+stDest+"<i></b><br/></div>");
        	
        			
        	//
        	
        	//Log.d("LECTURA", store.toString());
    		
    		txt.append("<br/></body></html>");
    		//texto.loadData(txt.toString(),mimetype,encoding);
    		
    		final String mimeType = "text/html";
    	    final String encoding = "utf-8";
    	    final String html = "<h1>Header</h1><p>Custom HTML</p><p><img src=\"file:///android_asset/right-arrow.png\" /></p>";
    		
    		texto.loadDataWithBaseURL("fake://not/needed",txt.toString() , mimeType, encoding, "");
    		
    		//texto.setTextColor(3);
    		//texto.setText("hola");
        	
        }catch(Exception e){
        	Log.e("TENGO ERRORES",e.toString());
        }
       
    }
	

}
