package es.guia.interfaz;

import es.guia.db.adapters.ImageAdapter;
import android.app.Activity;
import android.content.Context;
import android.content.res.TypedArray;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Gallery;
import android.widget.ImageView;
import android.widget.AdapterView.OnItemClickListener;

import java.util.*;

public class Galeria extends Activity {

    private Gallery gallery;
    private ImageView imgView;

   /* private Integer[] Imgid = { 
    		Menus.hImagenes.get("fraguavulcano_velazquez_b"), 
            R.drawable.hilanderas_velazquez_b, 
            R.drawable.meninas_velazquez_b, 
            R.drawable.rendicionbreda_velazquez_b, 
            R.drawable.venusespejo_velazquez_b,
            R.drawable.esopo_velazquez_b
    };*/
    
   private Integer[] Imgid=null;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.galeria);
        
        
        //Recuperando la galeria de imgenes del punto de interes
        String id=(String)(getIntent().getExtras()).get("id");    
        Log.i("Guia","Recuperando galeria del punto: "+id);
        
        ImageAdapter imageAdapter=new ImageAdapter(getApplicationContext());
        imageAdapter.open();
        
        Vector<String> galeria=imageAdapter.getGalleryImages(id);
        //for(int i=0;i<galeria.size();i++) Log.i("Guia","Recuperada "+galeria.elementAt(i));
        Imgid=new Integer[galeria.size()];
        for(int i=0;i<galeria.size();i++) Imgid[i]=Menus.hImagenes.get(galeria.elementAt(i));
        
        imgView = (ImageView)findViewById(R.id.ImageView01);	
        imgView.setImageResource(Imgid[0]);
        
        
         gallery = (Gallery) findViewById(R.id.galeriaobras);
         gallery.setAdapter(new AddImgAdp(this));

         gallery.setOnItemClickListener(new OnItemClickListener() {
            public void onItemClick(AdapterView parent, View v, int position, long id) {
                imgView.setImageResource(Imgid[position]); 
            	        
            }
        });

    }

    public class AddImgAdp extends BaseAdapter {
        int GalItemBg;
        private Context cont;

        public AddImgAdp(Context c) {
            cont = c;
            TypedArray typArray = obtainStyledAttributes(R.styleable.GalleryTheme);
            GalItemBg = typArray.getResourceId(R.styleable.GalleryTheme_android_galleryItemBackground, 0);
            typArray.recycle();
        }

        public int getCount() {
            return Imgid.length;
        }

        public Object getItem(int position) {
            return position;
        }

        public long getItemId(int position) {
            return position;
        }

        public View getView(int position, View convertView, ViewGroup parent) {
            ImageView imgView = new ImageView(cont);

            imgView.setImageResource(Imgid[position]);
            imgView.setLayoutParams(new Gallery.LayoutParams(80, 70));
            imgView.setScaleType(ImageView.ScaleType.FIT_XY);
            imgView.setBackgroundResource(GalItemBg);

            return imgView;
        }
    }

}