package es.guia.interfaz;

import es.guia.beans.*;
import es.guia.db.adapters.POIAdapter;
import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.*;


public class InformacionPOI extends Activity implements OnClickListener {
	
	
	private ImageView imgCabecera=null;
	private POI poi=null;
	
	@Override
	 public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.detalle_poi);
		
		 String id=(String)(getIntent().getExtras()).get("id");
		 
		 POIAdapter poiAdapter=new POIAdapter(getApplication());
		 poiAdapter.open();
		 
		 poi=poiAdapter.getPOI(id);
		 
		    		 
	     imgCabecera=(ImageView)findViewById(R.id.icon);
	     imgCabecera.setImageResource(Menus.hImagenes.get(poi.getImagen()));
	     
	     TextView titulo=(TextView)findViewById(R.id.titulo);
	     titulo.setText(poi.getNombre());
	     
	     String precio=poi.getPrecio();
	     String horario=poi.getHorario();
	     
	     if(!precio.equals("No Aplica")) precio=precio+" ";
	     
	     String contenido="\n\nPrecio: "+precio+"\n"+"Horario de apertura: "+horario;
	     
	     TextView cuerpo=(TextView)findViewById(R.id.cuerpo);
	     cuerpo.setText(contenido);
		 
		 
		 
		 Toast.makeText(getApplicationContext(), poi.getNombre(),  Toast.LENGTH_LONG).show();
	}
	
	public void onClick(View v){
		
		Log.d("=========================","Llegooooo");
		Log.d("InformacionPIO",String.valueOf(v.getTag()));
		
		Log.d("Longitud: ",poi.getLongitud());
		Log.d("Latitud: ",poi.getLatitud());
		
		Intent intento=new Intent(this, CalculoRuta.class);
			
		intento.putExtra("longitudDestino", poi.getLongitud());
		intento.putExtra("latitudDestino", poi.getLatitud());
		
		startActivity(intento);
	}
	
	  @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        MenuInflater inflater = getMenuInflater();
	        inflater.inflate(R.menu.menu_informacion_poi, menu);
	        return true;
	    }
	  
	  @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
		  
		  Intent intento=null;
	    	
	    	
	        switch (item.getItemId()) {
	            case R.id.desc_llegar:
	                
	            	intento=new Intent(InformacionPOI.this, CalculoRuta.class);
	            	intento.putExtra("longitudDestino", poi.getLongitud());
	        		intento.putExtra("latitudDestino", poi.getLatitud());
	                
	                break;
	            case R.id.desc_galeria:
	            	intento=new Intent(InformacionPOI.this,Galeria.class);
	            	intento.putExtra("id",poi.getId());
	                break;
	            case R.id.desc_info:
	               
	                break;
	            default:
	                return super.onOptionsItemSelected(item);
	        }
	        
	        startActivity(intento);
	         
	        return true;
		  
	  }
}
