package es.guia.interfaz;

import java.util.*;

import android.os.*;
import android.util.*;
import android.view.*;
import android.widget.*;
import android.content.*;
import android.app.ListActivity;

import es.guia.beans.*;
import es.guia.db.adapters.*;

public class ListadoPOIs extends ListActivity {
	   private List<POI> m_locals = null;
	   private IconListViewAdapter m_adapter;
	   private POIAdapter adapterPOI;
		
	    @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.listado_pois);        
	        
	        
	        m_locals=new ArrayList<POI>();
	        
	        this.m_adapter = new IconListViewAdapter(this, R.layout.poi_item, m_locals);
	        setListAdapter(this.m_adapter);  
	        
	        getPuntosDisponibles();
	        
	    }
	    
	    @Override
	    protected void onListItemClick(ListView l, View v, int position, long id) {
	       // Local local = (Local) l.getItemAtPosition(position);        
	       
	       // Toast.makeText(this, local.getLocalName(), 
	        ///  		Toast.LENGTH_LONG).show();
	    	//Intent intent = new Intent(IconListView.this, Museos.class);
			//startActivity(intent);
	    	
	    	Intent intento=new Intent(ListadoPOIs.this,DescripcionPOI.class);
	    	intento.putExtra("id", (m_locals.get(position)).getId());
	    	
	    	startActivity(intento);
	    	
	    	//Toast.makeText(getApplicationContext(), (m_locals.get(position)).getNombre(),  Toast.LENGTH_LONG).show();
	    	
	    }
	    
	    
	    
	    private void getPuntosDisponibles(){
	    	
	    	try {
	    		adapterPOI=new POIAdapter(getApplicationContext());
	    		
	    		adapterPOI.open();
	    		m_locals= adapterPOI.getAllPOIs();
	    		
	          } catch (Exception e) {
	            Log.e("BACKGROUND_PROC", e.getMessage());
	          }
	          
	          if(m_locals != null && m_locals.size() > 0){
	              for(int i=0;i<m_locals.size();i++)
	              m_adapter.add(m_locals.get(i));
	          }

	          m_adapter.notifyDataSetChanged();       	
	    	
	    }  
   

   public class IconListViewAdapter extends ArrayAdapter<POI> {

   	        private List<POI> items;

   	        public IconListViewAdapter(Context context, int textViewResourceId, List<POI> items) {
   	                super(context, textViewResourceId, items);
   	                this.items = items;
   	        }
   	        @Override
   	        public View getView(int position, View convertView, ViewGroup parent) {
   	                View v = convertView;
   	                if (v == null) {
   	                    LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
   	                    v = vi.inflate(R.layout.poi_item, null);
   	                }
   	                
   	                //Carga de elementos
   	                POI o = items.get(position);
   	                if (o != null) {
   	                	
   	                	//poblamos la lista de elementos
   	                	
   	                        TextView tt = (TextView) v.findViewById(R.id.row_toptext);
   	                        ImageView im = (ImageView) v.findViewById(R.id.icon);
   	                        
   	                        if (im!= null) {
   	                        	im.setImageResource(Menus.hImagenes.get(o.getImagen()));
   	                        }                        
   	                        if (tt != null) {             
   	                            tt.setText(o.getNombre());                             
   	                        }    	                    	                        
   	                }
   	                return v;
   	        }
   	}

}
