package es.guia.interfaz;

import java.util.*;

import android.content.Context;
import android.content.Intent;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;

import com.google.android.maps.*;

import es.guia.db.*;
import es.guia.db.adapters.*;
import es.guia.beans.*;
import es.guia.interfaz.*;
import es.guia.maps.gps.*;
import es.guia.maps.overlay.*;


public class MapaSituacion extends MapActivity {
	private static MapView mapView;
	private MapController mapController;
	private List <Overlay> mapOverlays;
	private LocationManager locationManager;
	private GeoUpdateHandler miGPS=null;

	public void onCreate(Bundle savedInstanceState){
		Log.i("Guia","Creando MapaSituacion");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.mapa_situacion);
		
		mapView=(MapView)findViewById(R.id.mapview);
		mapView.displayZoomControls(true);
		mapOverlays=mapView.getOverlays();
		mapController = mapView.getController();
		mapController.setZoom(17);
			
		updatePosition();
		
	}
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	public void onResume(){
		super.onResume();
		updatePosition();
	}
	
	private void updatePosition(){
		miGPS= new GeoUpdateHandler(this,mapController,mapView,mapOverlays,this);
		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		
		if(locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)){
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 5000, 5, miGPS);
		}else{
			Toast.makeText(getBaseContext(), "Proveedor de servicio GPS no encontrado", Toast.LENGTH_SHORT).show();
		}
		
		//Posicin actual
		Criteria criteria=new Criteria();
		String bestProvider=locationManager.getBestProvider(criteria, true);
		Location currentPos=locationManager.getLastKnownLocation(bestProvider);
		
		if(currentPos==null) return;
		
		Toast.makeText(getBaseContext(), "Localizacion actual: "+currentPos.getLatitude()+" "+currentPos.getLongitude(), Toast.LENGTH_SHORT).show();
		miGPS.onLocationChanged(currentPos);
		
	}
	
	public void onPause(){
		super.onPause();
		locationManager.removeUpdates(miGPS);
		Log.i("Guia","onPause: Eliminando el listener del GPS");
	}
	
	  @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        MenuInflater inflater = getMenuInflater();
	        inflater.inflate(R.menu.menu_principal, menu);
	        return true;
	    }
	  
	   @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
	    	return true;
	    	
	    }
	
	   
	   @Override
	protected void onDestroy() {
		super.onDestroy();
		Log.i("Guia","onDestroy: Eliminando el listener del GPS");
		//locationManager.removeUpdates(miGPS);
		if(miGPS!=null) miGPS=null;   
		System.gc();
		
		
		/*  final Intent poke = new Intent();
		    poke.setClassName("com.android.settings", 
		"com.android.settings.widget.SettingsAppWidgetProvider"); //$NON-NLS-1$//$NON-NLS-2$
		    poke.addCategory(Intent.CATEGORY_ALTERNATIVE);
		    poke.setData(Uri.parse("3")); //$NON-NLS-1$
		    getApplicationContext().sendBroadcast(poke);*/
		
		
		//Coordenadas de prueba iniciales: longitud: -3,6903  latitud: 40,4138
		
	}
	   
}
