package es.guia.interfaz;

import java.io.*;
import java.util.*;
import java.lang.reflect.Field;

import org.xmlpull.v1.XmlPullParser;


import com.google.android.maps.MapActivity;

import es.guia.db.*;
import es.guia.beans.*;
import es.guia.db.adapters.*;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.AssetManager;
import android.content.res.Resources;
import android.content.res.XmlResourceParser;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

import es.guia.util.*;

public class Menus extends Activity {
	public static final String APP_BASE_DIR="appBaseDir";
	public static final String FOTOGRAFIA="dirFotografia";
	public static final String BACKUP="backup";
	public static final String XML="xml";
	
	
	public static Hashtable <String, Integer> hImagenes = new Hashtable <String, Integer>();
	public static Hashtable <String,String> hResourcePath = new Hashtable <String, String>();
	
	private TextView texto;
	//private ImageView imgLogotipo;
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        //texto=(TextView)findViewById(R.id.texto);
        
        
        //Carga las Hashtable de imgenes
        directorios();
        
        try{
        	configuracion();
        }catch(Exception e){
        	Log.e("Guia",e.toString());
        }
        
        
    }
    
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_principal, menu);
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	
    	//Bundle b=new Bundle();	
    	//Context contexto=getApplicationContext();

    	Intent intento=null;
    	
    	
        switch (item.getItemId()) {
            case R.id.MnuOpc1:     
            	intento=new Intent(Menus.this, MapaSituacion.class);
                break;
            case R.id.MnuOpc2:
                intento=new Intent(Menus.this, POIUsuario.class);
            	
                break;
            case R.id.MnuOpc5:
                //texto.setText("Opcion 3 pulsada!");
                //b.putCharSequence("tipoPOI", "1");
                //intento.putExtra("tipoPOI", "3");
            	intento=new Intent(Menus.this,Ayuda.class);
                break;
            case R.id.MnuOpc4:
                intento=new Intent(Menus.this,ListadoPOIs.class);
                
                break;
            default:
                return super.onOptionsItemSelected(item);
        }
        
        startActivity(intento);
        
       
        
        return true;
    }

    /*
     * Mapea los objetos drawables para poder recuperarlos por nombre.
     */
    
	private void directorios(){
		Class resources = R.drawable.class;
		Field[] fields = resources.getFields();
		
		try{
			for (Field field : fields) {
				hImagenes.put(field.getName(),field.getInt(field));
			}
		}catch(Exception e){
			Log.e("Guia",e.getMessage());
		}
		
		Enumeration<String> en=hImagenes.keys();
		while(en.hasMoreElements()){
			String key=en.nextElement();
			Log.d(key,String.valueOf(hImagenes.get(key)));
		}
	}
	
	/**
	 * Recrea la configuracin necesaria, a nivel de propiedades y directorios, para que el aplicativo funcione
	 * 
	 * @throws IOException
	 */
	
	   private void configuracion() throws IOException{
		   //Lectura de propiedades
		   
		   Resources assetResources=this.getResources();
		   AssetManager assetManager=assetResources.getAssets();
			
		   Log.i("Guia","Leyendo propiedades de la aplicacin.");
		   Properties properties=null;
			try{
				InputStream in=assetManager.open("propiedades.properties");
				properties=new Properties();
				properties.load(in);
			}catch(Exception e){
				Log.e("Guia",e.toString());
			}
			
			Log.i("Guia","Inicializacin de propiedades completada.");
			Log.i("Guia","Recreando configuracin de la guia.");
		   
		   
			String appBaseDir=Environment.getExternalStorageDirectory()+properties.getProperty(APP_BASE_DIR);
			
			Log.i("Guia","Directorio base: "+appBaseDir);
			
			File fAppDir=new File(appBaseDir);
			
			if(!fAppDir.exists()){
				fAppDir.mkdir();
				Log.d("Guia","Creado directorio: "+appBaseDir);
				
				new File(appBaseDir+properties.getProperty(FOTOGRAFIA)).mkdir();
				new File(appBaseDir+properties.getProperty(BACKUP)).mkdir();
				new File(appBaseDir+properties.getProperty(XML)).mkdir();
			}
			
			hResourcePath=new Hashtable<String,String>();
			
			hResourcePath.put(APP_BASE_DIR, appBaseDir);
			hResourcePath.put(FOTOGRAFIA, appBaseDir+properties.getProperty(FOTOGRAFIA));
			hResourcePath.put(BACKUP, appBaseDir+properties.getProperty(BACKUP));
			hResourcePath.put(XML, appBaseDir+properties.getProperty(XML));
			
			//getResources().getXml(id)
			
			Log.i("Guia","La configuracin se ha recreado correctamente.");
			Log.d("Guia","Fotografa: "+hResourcePath.get(FOTOGRAFIA));
			Log.d("Guia","XML: "+hResourcePath.get(XML));
		}
	   
	 /**
	  * Comprobacin del estado de la SDCard  
	  * @return
	  */
	   private boolean	checkExternalMedia(){
			boolean mExternalStorageAvailable = false;
			boolean mExternalStorageWriteable = false;
			String state = Environment.getExternalStorageState();

			if (Environment.MEDIA_MOUNTED.equals(state)) {
			    // We can read and write the media
			    mExternalStorageAvailable = mExternalStorageWriteable = true;
			} else if (Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
			    // We can only read the media
			    mExternalStorageAvailable = true;
			    mExternalStorageWriteable = false;
			} else {
			    // Something else is wrong. It may be one of many other states,but all we need
			    //  to know is we can neither read nor write
				Log.i("Guia","State="+state+" Not good");
			    mExternalStorageAvailable = mExternalStorageWriteable = false;
			}

			Log.i("Guia","Available="+mExternalStorageAvailable+"Writeable="+mExternalStorageWriteable+" State"+state);
			return (mExternalStorageAvailable && mExternalStorageWriteable);
		}
	   
	   
	   

}