package es.guia.interfaz;

import java.io.*;
import java.util.*;

import es.guia.beans.*;
import es.guia.maps.gps.*;
import es.guia.db.adapters.*;

import android.location.Location;
import android.media.MediaScannerConnection;
import android.net.*;
import android.util.Log;
import android.view.*;
import android.widget.*;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.media.MediaScannerConnection.MediaScannerConnectionClient;



public class POIUsuario extends Activity implements View.OnFocusChangeListener{
	private static final int TAKE_PICTURE = 1;
	private static final int SELECT_PICTURE = 2;
	
	boolean fotoTomada=false;
	int posSeleccionada=0;
	
	String name=null;
	ImageView previsualizar=null;
	Bitmap foto=null;
	
	
	POIAdapter poiAdapter=null;
	static String[] SITIOS;
	List<POI> lista=null;
	
	AutoCompleteTextView nombre=null;
	TextView descripcion=null;
	
	/*
	 * Mtodo de creacin de la actividad.
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	
	  @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.gestionar_poi_usuario);
	        
	        //Inicializacin de posicin seleccionada
	        posSeleccionada=-1;
	        
	        poiAdapter=new POIAdapter(getApplicationContext());
	        poiAdapter.open();
	        
	        autocomplete();
	             
	        //Previsualizacin de imagen
	        previsualizar=(ImageView)findViewById(R.id.poi_previsualizar);
	        previsualizar.setDrawingCacheEnabled(false);
	        
	        //
	        
	       if(savedInstanceState!=null){
	    	    name=savedInstanceState.getString("name");
	        	foto=BitmapFactory.decodeFile(name);
				int w = foto.getWidth();
				int h = foto.getHeight();
				// Matriz contenedora de imagen
				Matrix mtx = new Matrix();
				mtx.postRotate(90);
				// Rotacin de Bitmap
				foto = Bitmap.createBitmap(foto, 0, 0, w, h, mtx, true);
				BitmapDrawable bmd = new BitmapDrawable(foto);

				previsualizar.setImageDrawable(bmd);
	        }
	        
	    }
	  	  
	  @Override
	    public boolean onCreateOptionsMenu(Menu menu) {
	        MenuInflater inflater = getMenuInflater();
	        inflater.inflate(R.menu.menu_gestionar_punto_usuario, menu);
	        return true;
	    }
	  
	  
	  
	  /*
	   * Control de acciones pulsadas.
	   * @see android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	   */
	  @Override
	    public boolean onOptionsItemSelected(MenuItem item) {
	     	
		  Intent intento =  null; 
		  
	      switch (item.getItemId()) {
	            case R.id.usuario_poi_camara:     
	            	intento=new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
	            	
	            	//Configuracin de ruta
	            	name=Environment.getExternalStorageDirectory()+"/test.jpg";
			       
	            	Uri output = Uri.fromFile(new File(name));
	            	intento.putExtra(MediaStore.EXTRA_OUTPUT,output);
	            	startActivityForResult(intento,TAKE_PICTURE);
	            	return true;
	            
	            case R.id.usuario_poi_guardar:
	            	
	            	if(nombre.getText().length()==0){
	            		Toast.makeText(getBaseContext(), "Debe introducir un nombre para el punto.", Toast.LENGTH_SHORT).show();
	            		return true;
	            	}if(descripcion.getText().length()==0){
	            		Toast.makeText(getBaseContext(), "Debe introducir una descripcion para el punto.", Toast.LENGTH_SHORT).show();
	            		return true;
	            	}else if(name==null){
	            		Toast.makeText(getBaseContext(), "Debe hacer una fotografia al punto o seleccionar desde la galeria.", Toast.LENGTH_SHORT).show();
	            		return true;
	            	}
	            	
	            	POI poi=new POI();
	            	poi.setNombre(nombre.getText().toString());
	            	poi.setDesc_breve(descripcion.getText().toString());
	            	poi.setDesc_larga(descripcion.getText().toString());
	            	
	            	Location loc=new GeoUpdateHandler(this).getCurrentLocation();
	            	
	            	poi.setLatitud(String.valueOf(loc.getLatitude()));
	            	poi.setLongitud(String.valueOf(loc.getLongitude()));
	            	
	            	poi.setTipoPOI("4");
	            	
	            	try{
	            		poi.setImagen(saveToFile(foto));
	            		Log.d("Guia","Foto insertada correctamente en directorio fotografico.");
	            	}catch(IOException io){
	            		Log.e("Guia", "Error copiando foto seleccionada de galeria:\n"+io.toString());
	            	}
	            	
	            	Log.d("Guia",poi.toString());
	            	
	            	poiAdapter.open();
	            	poiAdapter.insertUserPOI(poi);
	            	
	            	Toast.makeText(getBaseContext(), "El punto ha sido guardado", Toast.LENGTH_SHORT).show();
	            	onCreate(null); //Llamada a inicializar la actividad
	                break;
	         
	            case R.id.usuario_poi_borrar:
	                //intento=new Intent(Menus.this,ListadoPOIs.class);
	            	if(posSeleccionada!=-1){
	            		Log.i("Guia","Borrando el punto: "+lista.get(posSeleccionada).getNombre());
	            		
	            		poiAdapter.open();
	            		poiAdapter.delete(lista.get(posSeleccionada));
	            		
	            		try{
	            			eraseFile(lista.get(posSeleccionada).getImagen());
	            		}catch(IOException io){
	            			Log.e("Guia","Error borrando imagen asociada: "+io.toString());
	            		}
	            		
	            		posSeleccionada=-1;
	            		Toast.makeText(getBaseContext(), "El punto ha sido borrado", Toast.LENGTH_SHORT).show();
	            		onCreate(null); //Llamada a inicializar la actividad
	            	}else 
	            		Toast.makeText(getBaseContext(), "Introduzca el nombre del punto a borrar en Nombre del Punto", Toast.LENGTH_SHORT).show();
	            		
	                break;
	            case R.id.usuario_poi_galeria:
	            	intento = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.INTERNAL_CONTENT_URI);
	            	//Configuracin de ruta
	            	name=Environment.getExternalStorageDirectory()+"/test.jpg";
	            	startActivityForResult(intento,SELECT_PICTURE);
	            	
	            default:
	                return super.onOptionsItemSelected(item);
	        }
	         
	        return true;
	    }
	  
	  @Override 
	  protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		  Log.d("POIUsuario---=======================&&&=============================>","Vuelvo de la llamada: requestCode ="+requestCode+"  resultCode="+resultCode);
		  switch(requestCode){
		  	case TAKE_PICTURE:
		  		
		  		fotoTomada=true;
		  		if (data != null){	
		  			if (data.hasExtra("data")){
		  				Log.d("Guia","TAKE PICTURE con extra");
		  				foto=(Bitmap)data.getParcelableExtra("data");
		  				int w = foto.getWidth();
		  				int h = foto.getHeight();
		  				// Setting post rotate to 90
		  				Matrix mtx = new Matrix();
		  				mtx.postRotate(90);
		  				// Rotating Bitmap
		  				foto = Bitmap.createBitmap(foto, 0, 0, w, h, mtx, true);
		  				BitmapDrawable bmd = new BitmapDrawable(foto);
		  				previsualizar.setImageDrawable(bmd);
		  				/*try{
		  					saveToFile(foto);
		  				}catch(IOException io){
		  					Log.e("CameraTrial","Error comprimiendo: "+io.toString());
		  				}*/
		  			}
		  		}else{
		  			Log.d("Guia","NO Tiene extra");
		    		foto=BitmapFactory.decodeFile(name);
	  				int w = foto.getWidth();
	  				int h = foto.getHeight();
	  				// Setting post rotate to 90
	  				Matrix mtx = new Matrix();
	  				mtx.postRotate(90);
	  				// Rotating Bitmap
	  				foto = Bitmap.createBitmap(foto, 0, 0, w, h, mtx, true);
	  				BitmapDrawable bmd = new BitmapDrawable(foto);

	  				previsualizar.setImageDrawable(bmd);
	  				
	  				/*try{
	  					saveToFile(foto);
	  				}catch(IOException io){
	  					Log.e("Guia","Error comprimiendo: "+io.toString());
	  				}*/

		    		
		    		new MediaScannerConnectionClient() {
		    			private MediaScannerConnection msc = null; {
		    				msc = new MediaScannerConnection(getApplicationContext(), this); msc.connect();
		    			}
		    				public void onMediaScannerConnected() { 
		    					msc.scanFile(name, null);
		    				}
		    				public void onScanCompleted(String path, Uri uri) { 
		    					msc.disconnect();
		    				} 
		    			};				
		    		}
		  		break;
		  	case SELECT_PICTURE:
		  		Uri selectedImage = data.getData();
	    		InputStream is;
	    		try {
	    			is = getContentResolver().openInputStream(selectedImage);
	    	    	BufferedInputStream bis = new BufferedInputStream(is);
	    	    	foto = BitmapFactory.decodeStream(bis);            
	    	    	previsualizar.setImageBitmap(foto);		
	    	    	
	    		} catch (FileNotFoundException e) {}
	    	
		  		break;
		  	default:  
		  }
	  }
	  
	  @Override
	  protected void onSaveInstanceState(Bundle outState){
		  if(name!=null) outState.putString("name", name);
		  poiAdapter.close();
		  super.onSaveInstanceState(outState);

	  }
	  
	  @Override
	  protected void onPause(){
		  super.onPause();

	  }
	  
	  @Override
	  protected void onDestroy(){
		  poiAdapter.close();
		  super.onDestroy();
	  }
	  
	  
	  
	  private String saveToFile(Bitmap b) throws IOException{
		    String fileName=String.valueOf(Calendar.getInstance().getTimeInMillis())+".jpg";
		    Log.i("Guia","path: "+Menus.hResourcePath.get(Menus.FOTOGRAFIA));
	        OutputStream fOut = null;
	        File file = new File(Menus.hResourcePath.get(Menus.FOTOGRAFIA), fileName);
	        fOut = new FileOutputStream(file);

	           
	        b.compress(Bitmap.CompressFormat.JPEG, 70, fOut);
	        fOut.flush();
	        fOut.close();

	        MediaStore.Images.Media.insertImage(getContentResolver(),file.getAbsolutePath(),file.getName(),file.getName());
	        
	        return fileName;
	  }
	  
	  private void eraseFile(String name) throws IOException{
		  Log.i("Guia","Borrando: "+Menus.hResourcePath.get(Menus.FOTOGRAFIA)+"/"+name);
		  
		  File f=new File(Menus.hResourcePath.get(Menus.FOTOGRAFIA)+"/"+name);
		  f.delete();
		  
		  Log.d("Guia","Imagen asociada borrada");

	  }
	  
	  /*
	   * Consulta para autocompletar puntos de usuario.
	   * 
	   */
	  private void autocomplete(){
		  Log.d("Guia","Construyendo estructura para autocompletar");
	    
	      lista=poiAdapter.getAllUserPOIs();
	      
	        
	      SITIOS=new String[lista.size()];
	      for(int i=0;i<lista.size();i++) SITIOS[i] = (lista.get(i)).getNombre();
	        
	      //  for(int i=0;i<SITIOS.length;i++) Log.d("Guia", SITIOS[i]);
	     
	        
	      //Opciones de autocompletar
	      ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_dropdown_item_1line, SITIOS);
	      nombre = (AutoCompleteTextView)findViewById(R.id.poi_usuario_nombre_auto);
	      nombre.setAdapter(adapter);
	      
	      nombre.setOnFocusChangeListener(this);
	      Log.d("Guia","Construccin de autocompletar finalizada");
	      
	      descripcion=(TextView)findViewById(R.id.poi_usuario_desc);
	  }
	  
	  public void onFocusChange(View arg0, boolean arg1) {
		  Log.d("Guia","Entro");
			if(lista!=null && SITIOS!=null){
				Log.d("Guia",nombre.getText().toString());
				int i=0;
				for(i=0;i<SITIOS.length;i++){
					if(SITIOS[i].equals((nombre.getText()).toString())){
						descripcion.setText(lista.get(i).getDesc_breve());
						posSeleccionada=i;
						
						//Cargar la foto
						try{
							Log.d("Guia","cargado la imagen: "+Menus.hResourcePath.get(Menus.FOTOGRAFIA)+"/"+lista.get(i).getImagen());
							FileInputStream in = new FileInputStream(Menus.hResourcePath.get(Menus.FOTOGRAFIA)+"/"+lista.get(i).getImagen());
			    	    	foto = BitmapFactory.decodeStream(in);            
			    	    	previsualizar.setImageBitmap(foto);		
							
						}catch(Exception io){ Log.d("Guia",io.toString());}

						break;
					}
				}
			}
		}
	  
}

































/**
*    public class bitmaptest extends Activity {
        @Override
        public void onCreate(Bundle icicle) {
            super.onCreate(icicle);
            LinearLayout linLayout = new LinearLayout(this);
           
            // load the origial BitMap (500 x 500 px)
            Bitmap bitmapOrg = BitmapFactory.decodeResource(getResources(),
                   R.drawable.android);
           
            int width = bitmapOrg.width();
            int height = bitmapOrg.height();
            int newWidth = 200;
            int newHeight = 200;
           
            // calculate the scale - in this case = 0.4f
            float scaleWidth = ((float) newWidth) / width;
            float scaleHeight = ((float) newHeight) / height;
           
            // createa matrix for the manipulation
            Matrix matrix = new Matrix();
            // resize the bit map
            matrix.postScale(scaleWidth, scaleHeight);
            // rotate the Bitmap
            matrix.postRotate(45);
     
            // recreate the new Bitmap
            Bitmap resizedBitmap = Bitmap.createBitmap(bitmapOrg, 0, 0,
                              width, height, matrix, true);
       
            // make a Drawable from Bitmap to allow to set the BitMap
            // to the ImageView, ImageButton or what ever
            BitmapDrawable bmd = new BitmapDrawable(resizedBitmap);
           
            ImageView imageView = new ImageView(this);
           
            // set the Drawable on the ImageView
            imageView.setImageDrawable(bmd);
         
            // center the Image
            imageView.setScaleType(ScaleType.CENTER);
           
            // add ImageView to the Layout
            linLayout.addView(imageView,
                    new LinearLayout.LayoutParams(
                          LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT
                    )
            );
           
            // set LinearLayout as ContentView
            setContentView(linLayout);
        }
    }

*/