package es.guia.maps.overlay;

import android.app.AlertDialog;
import android.content.Context;
import android.graphics.drawable.Drawable;
import android.widget.Toast;

import com.google.android.maps.*;
import java.util.*;

public class UserItemizedOverlay extends ItemizedOverlay{
	
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Context mContext=null;
	private String calle=null;

	public UserItemizedOverlay(Drawable arg0) {
		super(boundCenterBottom(arg0));
	}
	
	public UserItemizedOverlay(Drawable defaultMarker, Context context) {
		  super(boundCenterBottom(defaultMarker));
		  mContext = context;
	}
	
	public UserItemizedOverlay(Drawable defaultMarker, Context context, String calle) {
		  super(boundCenterBottom(defaultMarker));
		  mContext = context;
		  this.calle=calle;
	}

	@Override
	protected OverlayItem createItem(int i) {
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		return mOverlays.size();
	}
	
	public void addOverlay(OverlayItem overlay) {
	    mOverlays.add(overlay);
	    populate();
	}
	
	@Override
	protected boolean onTap(int index) {
		OverlayItem item = mOverlays.get(index);
		AlertDialog.Builder dialog = new AlertDialog.Builder(mContext);
	    dialog.setTitle(item.getTitle());
	    dialog.setMessage(calle);
	    dialog.setIcon(es.guia.interfaz.R.drawable.icon);
	    dialog.show();
		
		
	  return true;
	}
	
	

}
