package es.guia.util;

import java.util.Vector;

import org.xmlpull.v1.XmlPullParser;

import android.content.res.Resources;
import android.content.res.XmlResourceParser;
import android.util.Log;
import es.guia.beans.POI;
import es.guia.interfaz.R;

public class XMLReaderHelper {
	private XmlResourceParser xmlFile=null;
	
	public XMLReaderHelper(XmlResourceParser xmlFile){
		this.xmlFile=xmlFile;
		
	}
	
	public Vector<POI> getPOIs(){
		Vector<POI> listaPois=new Vector<POI>();
		
		//XmlResourceParser xmlFile = resources.getXml(R.xml.lista_pois);
		
		try{
			xmlFile.next();//Get next parse event
			int eventType = xmlFile.getEventType(); //Get current xml event i.e., START_DOCUMENT etc.
			
			POI poi=null;
			while (eventType != XmlPullParser.END_DOCUMENT){  
				
				
			    if(eventType == XmlPullParser.START_DOCUMENT){     
			        Log.i("Guia","Comienza el catalogo de puntos de inters");
			    }else if(eventType == XmlPullParser.START_TAG){
			    	String nameTag=xmlFile.getName();
			    	if(nameTag.equals("poi")){
			    		String nombre=xmlFile.getAttributeValue(0);
			    		String latitud=xmlFile.getAttributeValue(1);
			    		String longitud=xmlFile.getAttributeValue(2);
			    		String tipo=xmlFile.getAttributeValue(3);
			    		String precio=xmlFile.getAttributeValue(4);
			    		String horario=xmlFile.getAttributeValue(5);
			    	
			    		
			    		poi=new POI();
			    		
			    		poi.setNombre(nombre);
						poi.setLongitud(longitud);
						poi.setLatitud(latitud);
						poi.setTipoPOI(tipo);
						poi.setPrecio(precio);
						poi.setHorario(horario);
			    	}else if(nameTag.equals("imagen")){
			    		xmlFile.next();
			    		String imagen=xmlFile.getText();
			    		Log.d("Guia","Imagen: "+imagen);
			    		poi.setImagen(imagen);
			    	}else if(nameTag.equals("descBreve")){
			    		xmlFile.next();
			    		String descBreve=xmlFile.getText();
			    		Log.d("Guia","DescBreve: "+descBreve);
			    		poi.setDesc_breve(descBreve);
			    	}else if(nameTag.equals("descLarga")){
			    		xmlFile.next();
			    		String descLarga=xmlFile.getText();
			    		Log.d("Guia","DescLarga: "+descLarga);
			    		poi.setDesc_larga(descLarga);
			    	}else if(nameTag.equals("imagenGaleria")){
			    		Log.i("Guia", "PASO POR LA GALERIA DE IMAGENES");
			    		xmlFile.next();
			    		String imagenGaleria=xmlFile.getText();
			    		Log.i("Guia",imagenGaleria);
			    		poi.addImagenGaleria(imagenGaleria);
			    	}
			    }else if(eventType==XmlPullParser.TEXT){
			    	Log.d("Guia",xmlFile.getText());
			    }else if(eventType==XmlPullParser.END_TAG){
			    	if(xmlFile.getName().equals("poi")){
			    		//Aadir a la lista
			    		Log.d("Guia","Cerrando poi: "+poi.toString());
			    		listaPois.add(poi);
			    	}
			    }
			    
			    xmlFile.next();
			    eventType=xmlFile.getEventType();
			}
		}catch(Exception e){
			Log.e("Guia",e.toString());
		}
		
		Log.i("Guia","Resumen de puntos leidos");
		Log.i("Guia","======================");
		for(int i=0;i<listaPois.size();i++){
			POI a=listaPois.elementAt(i);
			Log.i("Guia",a.toString());
		}
		
		return listaPois;
	}

}
